/**
 * @file
 * This is jQuery code to refresh the block content, play adhan and more.
 */

Drupal.behaviors.adhan = function(context) {
  if (!Drupal.settings.adhan['queueCompass']) {
    setTimeout(refreshCompass, Drupal.settings.adhan['refreshCompass'] * 1000);
    Drupal.settings.adhan['queueCompass'] = true;
  }

  var time = new Date().getTime() / 1000;
  for (var i = 1; i < 9; i++) {
    if (i == 8) {
      break;
    }
    if (time < Drupal.settings.adhan.times[i]) {
      break;
    }
  }
  if (i != Drupal.settings.adhan.current) {
    if (i == 8) {
      refreshTable();
    }
    else {
      playAdhan(i);
    }
  }

  setTimeout(Drupal.behaviors.adhan, 20000);
}

var refreshCompass = function() {
  $.ajax({
    url: Drupal.settings.adhan.basePath + "calc-compass",
    dataType: "json",
    success: function(response) {
      if (response !== false) {
        $('#block-adhan-0-compass').attr('src', response.url);
      }
    },
  });

  Drupal.settings.adhan['queueCompass'] = false;
};

var refreshTable = function() {
  $.ajax({
    url: Drupal.settings.adhan.basePath + "calc-times",
    dataType: "json",
    success: function(response) {
      if (response !== false) {
        Drupal.settings.adhan.times = response.times;
        $('#block-adhan-0 .time').each(function(i) {
          $(this).html(response.table[i]);
          if (i == 1) {
            $(this).parent().addClass('next');
          }
          else {
            $(this).parent().removeClass('current');
            $(this).parent().removeClass('next');
          }
        });
      }
    },
  });

  Drupal.settings.adhan.current = 1;
}

var playAdhan = function(index) {
  $('#block-adhan-0 .prayer').each(function(i) {
    if (i == index - 2 && i != 1) {
      $(this).addClass('current');
    }
    else {
      $(this).removeClass('current');
    }
    if (i == index - 1) {
      $(this).addClass('next');
    }
    else {
      $(this).removeClass('next');
    }
  });

  var jquery_ui = Drupal.settings.adhan.jquery_ui;
  if ((index == 2 || index > 3 && index < 8) && jquery_ui) {
    $.ajax({
      url: Drupal.settings.adhan.basePath + "notification-" + (index - 2),
      dataType: "json",
      success: function(response) {
        var dialog = $('#adhan-dialog');
        var title = response.title;
        var content = response.content;

        if(dialog.dialog('isOpen')) {
          dialog.dialog('destroy');
        }
        dialog.html(content);
        dialog.show();
        dialog.dialog({
          title: title,
          modal: true,
          closeText: '',
          buttons: {
            'Ok': function() {
              $(this).dialog('destroy');
              $(this).html('');
            }
          }
        });

        // jQuery appears to contain a bug, fix it with this
        dialog.css('height', 'auto');
        dialog.css('width', 'auto');
        $('.ui-dialog-buttonpane').css('width', '100%');
      },
    });
  }

  Drupal.settings.adhan.current = index;
}